/* 
   J. Dean Brock, 1998

   Written for UNCA CSCI 343

   Main user-level routine for updating the B+-tree

   Call as
        bupdate btree-file key new-value

   Revised 2017 for CSCI 235 example

*/


#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#include "btree.h"

#define DEFAULTBEG  0
#define DEFAULTEND -1

main(int argc, char *argv[])
 {
  int rc ;
  int errflg = 0 ;
  int   valNew ;
  FILE * dbFile ;
  char *atoiHack = NULL ;
  char usage[]
        = "bupdate file-name key value\n" ;
  simpRecT oldRec, newRec ;

  if (argc != 4) {
    (void) fputs(usage, stderr) ;
    exit(1) ;
  }    

  valNew = (int) strtol(argv[3], &atoiHack, 10) ;
  if (valNew<0 || errno || atoiHack[0]) {
    (void) fprintf(stderr, "New value must be an integer (%s)\n", argv[3]) ;
    exit(1) ;
  }

  if ((dbFile = fopen(argv[1], "r+")) == (FILE *)NULL) {
    (void) fprintf(stderr, "Unable to open %s\n", argv[1]) ;
    perror("fopen") ;
    exit(1) ;
  }

  bzero((void *)&newRec, sizeof(simpRecT)) ;
  strncpy(newRec.name, argv[2], 12) ;
  newRec.value = valNew ;

  rc = btreeUpdate(dbFile, &oldRec, &newRec) ;
  if (rc == -1)
    (void) fprintf(stdout, "Record update failed:  (%.12s, %d)\n",
		   newRec.name, newRec.value) ;
  else if (rc == 1)
    (void) fprintf(stdout, "Record updated: (%.12s,%d)-> (%.12s,%d)\n",
		   oldRec.name, oldRec.value,
		   newRec.name, newRec.value) ;
  else
    (void) fprintf(stdout, "Record added:  (%.12s, %d)\n",
		   newRec.name, newRec.value) ;

  (void) fclose(dbFile) ;

 }
